

#include "spi_controller.h"

#include "port_define.h"


#define SPI_INSTANCE_ID            0

NRF_SPI_MNGR_DEF(m_nrf_spi_mngr, 48, SPI_INSTANCE_ID);


ret_code_t spi_init(void){
	// SPI0 (with transaction manager) initialization.
	nrf_drv_spi_config_t const m_master0_config =
	{
		.sck_pin        = SCLK_BUS,
		.mosi_pin       = SIMO_BUS,
		.miso_pin       = SOMI_BUS,
		.ss_pin         = CS_ADS,
		.irq_priority   = APP_IRQ_PRIORITY_LOWEST,
		.orc            = 0xFF,
		.frequency      = NRF_DRV_SPI_FREQ_2M,
		.mode           = NRF_DRV_SPI_MODE_1,
		.bit_order      = NRF_DRV_SPI_BIT_ORDER_MSB_FIRST
	};
	return nrf_spi_mngr_init(&m_nrf_spi_mngr, &m_master0_config);
}


void performSPI(nrf_spi_mngr_transfer_t const * p_transfers, uint8_t number_of_transfers, void (* user_function)(void)){
	ret_code_t err_code;
	err_code = nrf_spi_mngr_perform(&m_nrf_spi_mngr, NULL, p_transfers, number_of_transfers, user_function);
	APP_ERROR_CHECK(err_code);
}


void scheduleSPI(nrf_spi_mngr_transaction_t const * p_transaction){
	uint32_t err_code;
	err_code = nrf_spi_mngr_schedule(&m_nrf_spi_mngr, p_transaction);
	APP_ERROR_CHECK(err_code);
}

